#include "Colors.h"

QString  Colors::required ()
{
   return QObject::tr("#fffacd"); // lemon chiffon from rgb.txt
}

QString  Colors::action ()
{
   return QObject::tr("blue");
}

QString  Colors::error ()
{
   return QObject::tr("red");
}

QString  Colors::errorDisabled ()
{
   return QObject::tr("#ffa9b8"); // pink2 from rgb.txt
}

QString  Colors::warning ()
{
   return QObject::tr("darkorange");
}

QString  Colors::minor ()
{
   return QObject::tr("#8b5a2b"); // tan4 from rgb.txt
}

QString  Colors::minorDisabled ()
{
   return QObject::tr("#ffbd94"); // hand-crafted (lighter than tan1)
}

QString  Colors::ok ()
{
   return QObject::tr("green");
}

QPalette Colors::makeRequired (const QPalette&  p)
{
   static const QColor*  requiredColor = NULL;
   if (requiredColor == NULL) {
      requiredColor = new QColor(required());
   }

   QPalette result = p;
   result.setColor(QPalette::Active,   QPalette::Base, *requiredColor);
   result.setColor(QPalette::Inactive, QPalette::Base, *requiredColor);
   return result;
}

QPalette Colors::makeError (const QPalette&  p)
{
   static const QColor*  errorColor = NULL;
   if (errorColor == NULL) {
      errorColor = new QColor(error());
   }

   QPalette result = p;
   result.setColor(QPalette::WindowText, *errorColor);
   return result;
}

QPalette Colors::makeWarning (const QPalette&  p)
{
   static const QColor*  warningColor = NULL;
   if (warningColor == NULL) {
      warningColor = new QColor(warning());
   }

   QPalette result = p;
   result.setColor(QPalette::WindowText, *warningColor);
   return result;
}

QPalette Colors::makeOK (const QPalette&  p)
{
   static const QColor*  okColor = NULL;
   if (okColor == NULL) {
      okColor = new QColor(ok());
   }

   QPalette result = p;
   result.setColor(QPalette::WindowText, *okColor);
   return result;
}
