#ifndef Colors_h
#define Colors_h

#include <QtGui/QPalette>

namespace Colors {

   // Color names
   extern QString  required      ();
   extern QString  action        ();
   extern QString  error         ();
   extern QString  errorDisabled ();
   extern QString  warning       ();
   extern QString  minor         ();
   extern QString  minorDisabled ();
   extern QString  ok            ();

   // Changes the Base (background) color of Text Input widgets to imply a
   // required field.
   extern QPalette makeRequired (const QPalette&  p);

   // Changes the WindowText (foreground) color of widgets to imply an error,
   // warning, or OK message.
   extern QPalette makeError    (const QPalette&  p);
   extern QPalette makeWarning  (const QPalette&  p);
   extern QPalette makeOK       (const QPalette&  p);

};

#endif
