#include "HMenu.h"
#include <QtGui/QtEvents>
#include <QtGui/QToolTip>

HMenu::HMenu(QString    title,
             QMenuBar*  menuBar)
   : QMenu(title, menuBar)
{
   setTearOffEnabled(true);
}

bool HMenu::event(QEvent*  event)
{
   if (event->type() == QEvent::ToolTip) {
      QHelpEvent*  helpEvent = dynamic_cast<QHelpEvent*>(event);
      QMenu*       menu      = this;
      QAction*     action    = NULL;

      while (menu != NULL) {
         action = menu->activeAction();
         if (action == NULL) break;
         menu = action->menu();
      }

      if (action != NULL) {
         QString  tip = action->toolTip();
         if (!tip.isEmpty()) {
            QString  text = action->text();
            text.remove("...");
            text.remove("&");
            if (tip != text) {
               QToolTip::showText(helpEvent->globalPos(), tip);
            }
         }
      }
   }

   return QMenu::event(event);
}
