#ifndef HSortFilterProxyModel_h
#define HSortFilterProxyModel_h

#include <QtGui/QSortFilterProxyModel>

// QSortFilterProxyModel with this extension:
//    Supports a secondary sort method used for rows whose sort columns
//       contain the same value

class HSortFilterProxyModel : public QSortFilterProxyModel {
public:
   explicit HSortFilterProxyModel(int       secondarySortColumn,
                                  QObject*  parent = NULL);
protected:
   bool lessThan(const QModelIndex&  left, 
                 const QModelIndex&  right) const;
   QModelIndex  createSecondarySortIndex(const QModelIndex&  ix) const;
public:
   int  secondarySortColumn;
};

#endif
