#ifndef HTextEdit_h
#define HTextEdit_h

#include <QtGui/QTextEdit>

// QTextEdit with this extension:
//    Sets the preferred height to the specified number of lines or,
//       if lines == -1, the default height of the QTextEdit.
//    Adds appendCompact member which appends paragraphs, but without
//       the extra top & bottom margins added for html paragraphs.
//    Adds editingFinished signal similar to that in QLineEdit, except
//       that only the text editor losing focus causes it to be edited
//       (because Enter and Return are editing characters in a text editor).

class HTextEdit : public QTextEdit {
   Q_OBJECT
public:
   explicit HTextEdit(QWidget*  parent);
   explicit HTextEdit(int       columns,
                      int       lines,
                      QWidget*  parent);
public:
   void appendCompact(const QString&  text);
signals:
   void editingFinished();
protected:
   QSize sizeHint() const;
   void  focusOutEvent(QFocusEvent*  ev);
protected:
   int  columns;
   int  lines;
};

#endif
