#ifndef Log_h
#define Log_h

#include <QtCore/QObject>
#include <QtCore/QList>
#include <QtCore/QMutex>

namespace Log {

   enum Kind {
      NORMAL,  // Normal text
      STDOUT,  // stdout text
      WARNING, // A warning
      ERROR,   // An error (including stderr text)
      ACTION   // Action (Initializing, Applying, etc.)
   };

   class Entry {
   public:
      Kind          kind;
      unsigned int  value;
      QString       text;
      
      explicit Entry(Kind          kind,
                     unsigned int  value,
                     QString       text) 
         : kind(kind), value(value), text(text)
      {}
   };

   class EntryList : public QObject, public QList<Entry>, public QMutex {
      Q_OBJECT
   public:
      virtual ~EntryList() {}
   signals:
      void appended();
   public:
      void emitAppended() { emit appended(); }
   };

};

#endif
