#ifndef LogWindow_h
#define LogWindow_h

#include "Log.h"
#include <QtGui/QWidget>
#include <QtGui/QSpinBox>
#include "HTextEdit.h"

namespace Log {

   // The log dialog, for displaying the log of all activities

   class Window : public QWidget {
      Q_OBJECT
   public:
      explicit Window(EntryList&  entries,
                      QWidget*    parent);
   public slots:
      void setVisible(bool visible);
   protected slots:
      void appended();
   protected:
      void htmlProtect(QString&  str);
   protected:
      void keyPressEvent(QKeyEvent*  event);
   protected slots:
      void levelChanged(int  level);
   protected:
      QWidget*    parent;
      QSpinBox*   levelSpinBox;
   protected:
      EntryList&  entries;
      HTextEdit*  textEdit;
      int         shownCount;
   };

};

#endif
