#ifndef PackageTableActionContextMenu_h
#define PackageTableActionContextMenu_h

#include "PackageTableModel.h"
#include <QtGui/QMenu>
#include <QtGui/QIcon>
#include <QtGui/QAction>

namespace PackageTable {

   class ActionContextMenu : public QMenu {
      Q_OBJECT
   public:
      explicit ActionContextMenu(Model*  model);
   public:
      void  exec(QModelIndex    ix,
                 const QPoint&  pos);
   protected slots:
      void  handleUpdateAction();
      void  handleInstallAction();
      void  handleRemoveAction();
      void  handleNoneAction();
   protected:
      QIcon  noneIcon;
      QIcon  updateIcon;
      QIcon  installIcon;
      QIcon  removeIcon;
   protected:
      QAction*  updateAction;
      QAction*  installAction;
      QAction*  removeAction;
      QAction*  noneAction;

      Model*       model;
      QModelIndex  ix;
   };

};

#endif
