#ifndef PackageTableDescribeDialog_h
#define PackageTableDescribeDialog_h

#include "YumIO.h"
#include <QtGui/QDialog>
#include "YumConfIO.h"
#include "Package.h"
#include <QtGui/QLayout>
#include <QtGui/QWidget>
#include <QtGui/QPushButton>
#include "PackageTableDescribeInstanceArea.h"

namespace PackageTable {
   namespace Describe {

      class Dialog : public QDialog {
      public:
         explicit Dialog(QWidget*  parent = NULL);
      public:
         void  config (YumIO*                 yumIO,
                       const Package::Entry&  entry,
                       YumConfIO*             yumConfIO);
         void  setVisible (bool  visible);
         void  setReady   (bool  ready);
      protected:
         void  done       (int           r);
         void  closeEvent (QCloseEvent*  event);
      protected:
         // So, why the extra descrWidget & layout?  To make removing & deleting
         // all the interior widgets easier, so that the dialog can be reused
         // for different packages.  The descrLayout (see the constructor) is a
         // layout that will have only a single widget: the descrWidget.
         QLayout*                descrLayout;
         QWidget*                descrWidget;
         QList<Instance::Area*>  instances;
         bool                    ready;
      protected:
         QPushButton*  closeButton;
      };

   };
};

#endif
