#ifndef PackageTableDescribeInstanceArea_h
#define PackageTableDescribeInstanceArea_h

#include "YumIO.h"
#include <QtCore/QObject>
#include "YumConfIO.h"
#include <QtGui/QWidget>
#include <QtGui/QPushButton>
#include <QtGui/QVBoxLayout>
#include <QtGui/QGridLayout>
#include "HScrollArea.h"
#include "PackageTableDescribeInstanceRepoDialog.h"
#include "TextDialog.h"

namespace PackageTable {
   namespace Describe {

      class Dialog;

      namespace Instance {

         class Area : public QObject {
            Q_OBJECT
         public:
            Area(Dialog*                dialog,
                 QVBoxLayout*           outerLayout,
                 YumIO*                 yumIO,
                 const Package::Entry&  entry,
                 YumConfIO*             yumConfIO,
                 bool                   primary);
            ~Area();
         protected:
            class Button {
            public:
               Button() : button(NULL), row(-1) {}
               QString       text;
               QPushButton*  button;
               int           row;
            };
         protected:
            void    addHeader     (int&     row,
                                   QString  text);
            void    addPair       (int&     row,
                                   QString  key,
                                   QString  value);
            Button  addPairButton (int&     row,
                                   QString  key,
                                   QString  value,
                                   QString  text);
            Button  addButton     (int&     row,
                                   QString  key,
                                   QString  text);
            void    updateButtons ();
            void    updateButton  (Button&  button,
                                   bool     collected);
         protected slots:
            void handleRepo();
            void handleFiles();
            void handleChangeLog();
         protected:
            Dialog*                dialog;
            YumIO*                 yumIO;
            const Package::Entry&  entry;
            YumConfIO*             yumConfIO;
         protected:
            QWidget*  parentWidget;
         protected:
            RepoDialog*  repoDialog;
            TextDialog*  textDialog;
         protected:
            QWidget*      widget;
            QGridLayout*  layout;
            HScrollArea*  scrollArea;
         protected:
            Button  files;
            Button  changeLog;
         };

      };
   };
};

#endif
