#ifndef PackageTableDescribeInstanceRepoDialog_h
#define PackageTableDescribeInstanceRepoDialog_h

#include "YumIO.h"
#include <QtGui/QDialog>
#include <QtGui/QLayout>
#include <QtGui/QWidget>
#include <QtGui/QGridLayout>
#include "Repo.h"

namespace PackageTable {
   namespace Describe {
      namespace Instance {

         class RepoDialog : public QDialog {
            Q_OBJECT
         public:
            explicit RepoDialog(YumIO*    yumIO,
                                QWidget*  parent = NULL);
         public:
            void  config(const Repo::Entry&  entry);
            void  setVisible(bool visible);
         protected:
            void  addPair (int&     row,
                           QString  key,
                           QString  value);
         protected slots:
            void  browse();
         protected:
            YumIO*              yumIO;
            const Repo::Entry*  entry;
         protected:
            // So, why the extra descrWidget & layout?  To make removing &
            // deleting all the interior widgets easier, so that the dialog
            // can be reused for different packages.  The descrLayout (see
            // the constructor) is a layout that will have only a single
            // widget: the descrWidget.
            QLayout*      descrLayout;
            QWidget*      descrWidget;
            QGridLayout*  gridLayout;
         };

      };
   };
};

#endif
