#include "PackageTableOtherContextMenu.h"
#include "PackageTable.h"

PackageTable::OtherContextMenu::OtherContextMenu(Model*    model,
                                                 QWidget*  parent)
   : QMenu(),
     model(model),
     parent(parent)
{
   describeAction  = new QAction(tr("&Describe"), this);
   browseAction    = new QAction(tr("Browse Repository"), this);

   addAction(describeAction);
   addAction(browseAction);

   connect(describeAction, SIGNAL(triggered()), 
           this, SLOT(handleDescribeAction()));
   connect(browseAction, SIGNAL(triggered()), 
           this, SLOT(handleBrowseAction()));
}

void  PackageTable::OtherContextMenu::exec(QModelIndex    ix,
                                           const QPoint&  pos)
{
   this->ix = ix;

   browseAction->setVisible(ix.column() == PackageTable::REPO);

   QMenu::exec(pos);
}

void  PackageTable::OtherContextMenu::handleDescribeAction()
{
   model->describe(ix, parent);
}

void  PackageTable::OtherContextMenu::handleBrowseAction()
{
   model->browse(ix, parent);
}
