#ifndef PackageTableView_h
#define PackageTableView_h

#include "YumIO.h"
#include "HTableView.h"
#include "PackageTableModel.h"
#include "PackageTableSortFilterProxyModel.h"
#include "PackageTableActionContextMenu.h"
#include "PackageTableOtherContextMenu.h"
#include <QtGui/QMenu>

namespace PackageTable {

   class View : public HTableView {
      Q_OBJECT
   public:
      explicit View(Model*       model,
                    StateFilter  stateFilter,
                    bool         groupsFilter,
                    YumIO*       yumIO,
                    QWidget*     parent       = NULL);
   public:
      void  setMode             (Mode            mode);
      void  setFilter           (bool            filter);
      void  filtersearch        (const QString&  regexp);
      void  stateFilterChanged  (StateFilter     stateFilter);
      void  groupsFilterChanged (bool            groupsFilter);
   public:
      QModelIndexList  selectedRows () const;
   protected:
      void  changeEvent (QEvent*  event);
   signals:
      void  currentChanged(int  currentRow,
                           int  previousRow);
      void  stateChanged  (int  row);
   public slots:
      void  resizeColumnsToContents ();
      void  describe                ();
   protected slots:
      void  handleHorizontalHeaderClicked    (int                 column);
      void  handleActivated                  (const QModelIndex&  ix);
      void  handleCustomContextMenuRequested (const QPoint&       pos);
      void  currentChanged                   (const QModelIndex&  current,
                                              const QModelIndex&  previous);
   protected:
      Model*                 model;
      SortFilterProxyModel*  sortedModel;
      ActionContextMenu*     actionContextMenu;
      OtherContextMenu*      otherContextMenu;
   };

};

#endif
