#include "ProgressMinion.h"

ProgressMinion::ProgressMinion(HProgressBar*  totalProgress,
                               HProgressBar*  itemProgress)
   : totalProgress(totalProgress),
     itemProgress(itemProgress)
{
   // Beware.  This object isn't necessarily in the main thread yet.
   // Don't try any GUI activities here.
}

void ProgressMinion::startTotal(QString  activity,
                                Steps    totalTail)
{
   totalProgress->setActivity(activity);
   totalProgress->setMaximum(totalTail);
   totalProgress->setValue(0);
   totalProgress->setEnabled(true);

   itemProgress->reset();
   itemProgress->setEnabled(false);
}

void ProgressMinion::startItem(QString  activity,
                               Steps    totalValue,
                               Steps    itemTail)
{
   totalProgress->setValue(totalValue);

   itemProgress->setActivity(activity);
   itemProgress->setMaximum(itemTail);
   itemProgress->setValue(0);
   itemProgress->setEnabled(true);
}

void ProgressMinion::changeItemActs (Steps  totalValue)
{
   totalProgress->setValue(totalValue);
}

void ProgressMinion::setItemValue(Steps  totalValue,
                                  Steps  value)
{
   totalProgress->setValue(totalValue);
   itemProgress->setValue(value);
}

void ProgressMinion::endItemActs(Steps  totalValue)
{
   totalProgress->setValue(totalValue);
}

void ProgressMinion::setTotalValue (Steps  value)
{
   totalProgress->setValue(value);
}

void ProgressMinion::reset()
{
   totalProgress->setMinimum(0);
   totalProgress->setMaximum(1);
   itemProgress->setMinimum(0);
   itemProgress->setMaximum(1);
   totalProgress->reset();
   itemProgress->reset();
   totalProgress->setEnabled(false);
   itemProgress->setEnabled(false);
}
