#ifndef Repo_h
#define Repo_h

#include <QtCore/QString>
#include <QtCore/QList>

namespace Repo {

   enum TriState {
      False,
      Unspecified,
      True
   };

   class Entry {
   public:
      QString    id;
      QString    name;
      QString    urls;
      QString    mirrorListUrl;
      TriState   enabled;
      TriState   checkGPGKeys;
      QString    otherOptions;
      QString    filename;
      double     sortPosition;

      explicit Entry()
         : enabled(Unspecified), 
           checkGPGKeys(Unspecified), 
           sortPosition(0.0)
      {}
      bool operator==(const Entry& r) const {
         return (   id            == r.id
                 && name          == r.name
                 && urls          == r.urls
                 && mirrorListUrl == r.mirrorListUrl
                 && enabled       == r.enabled
                 && checkGPGKeys  == r.checkGPGKeys
                 && otherOptions  == r.otherOptions
                 && filename      == r.filename
                 && sortPosition  == r.sortPosition);
      }
      bool operator!=(const Entry& r) const {
         return !(*this == r);
      }
   };

   typedef QList<Entry>  EntryList;

};

#endif
