#ifndef RepoAuthDialog_h
#define RepoAuthDialog_h

#include <QtGui/QDialog>
#include <QtGui/QLabel>
#include <QtGui/QLineEdit>
#include <QtCore/QEventLoop>
#include <QtGui/QPushButton>
#include "Repo.h"

namespace RepoAuth {

   class Dialog : public QDialog {
      Q_OBJECT
   public:
      explicit Dialog(QWidget*  parent);
   public:
      void exec(Repo::Entry*  entry);
      void done(int  r);
   protected:
      QSize sizeHint() const;
   protected slots:
      void authChanged  (const QString&  text);
      void handleQuit();
      void handleDisable();
      void handleSkipAll();
      void handleApplyAll();
      void handleApplyHost();
      void handleOK();
   protected:
      void setUrls();
   public:
      enum Result {
         Rejected, // as defined in QDialog::DialogCode (and used by Escape)
         Accepted, // as defined in QDialog::DialogCode
         SKIP_ALL = Rejected,
         OK       = Accepted,
         APPLY_ALL,
         APPLY_HOST,
         DISABLE,
         QUIT
      };
   protected:
      QLabel*       idValue;
      QLabel*       nameValue;
      QLabel*       urlsValue;
      QLabel*       mirrorListUrlValue;
      QLabel*       authNameLabel;
      QLineEdit*    authNameEdit;
      QLabel*       authPasswordLabel;
      QLineEdit*    authPasswordEdit;
      QPushButton*  quitButton;
      QPushButton*  disableButton;
      QPushButton*  skipAllButton;
      QPushButton*  applyAllButton;
      QPushButton*  applyHostButton;
      QPushButton*  okButton;
   protected:
      Repo::Entry*  entry;
      QEventLoop    eventLoop;
   };

};

#endif
