#ifndef RepoEditorConfigDialog_h
#define RepoEditorConfigDialog_h

#ifndef REPO_EDITOR_ONE_DIALOG

#include "HDialog.h"
#include "RepoEditorConfig.h"
#include "YumConfIO.h"
#include <QtGui/QPushButton>
#include <QtGui/QLabel>
#include <QtGui/QPalette>

namespace RepoEditor {

   // The repository editor config dialog, for configuring a single yum 
   // repository.

   // Avoid subclassing from QDialog because that comes with the "default
   // button" baggage which doesn't make any sense for this dialog.  Note
   // that keyPressEvent still supports using Escape to bail out of the
   // this dialog, though.
   class ConfigDialog : public HDialog {
      Q_OBJECT
   public:
      explicit ConfigDialog(YumConfIO*    yumConfIO,
                            QWidget*      parent);
   public:
      void setEntry (Repo::Entry*  entry);
   public:
      void setVisible (bool  visible);
   protected slots:
      void changed();
   protected slots:
      void reset();
      void cancel();
      void ok();
   protected:
      void updateStatusLabel ();
      void setHasChanged     (bool  value);
   protected:
      QWidget*      parent;
      QLabel*       statusLabel;
      QPushButton*  resetButton;
      Config*       config;
   protected:
      QPalette  statusLabelDefaultPalette;
   protected:
      YumConfIO*    yumConfIO;
      Repo::Entry*  entry;
   protected:
      bool  hasChanged;
   };

};

#endif

#endif
