#include "RepoEditorContextMenu.h"
#include "RepoEditor.h"

RepoEditor::ContextMenu::ContextMenu(Model*    model,
                                     QWidget*  parent)
   : QMenu(),
     model(model),
     parent(parent)
{
#ifndef REPO_EDITOR_ONE_DIALOG
   QAction*  editAction = new QAction(tr("Edit"), this);
   addAction(editAction);
   connect(editAction, SIGNAL(triggered()), this, SLOT(edit()));
#endif

   QAction*  browseAction = new QAction(tr("Browse Repository"), this);
   addAction(browseAction);
   connect(browseAction, SIGNAL(triggered()), this, SLOT(browse()));
}

void  RepoEditor::ContextMenu::exec(QModelIndex    ix,
                                    const QPoint&  pos)
{
   this->ix = ix;

   QMenu::exec(pos);
}

#ifndef REPO_EDITOR_ONE_DIALOG
void  RepoEditor::ContextMenu::edit()
{
   emit edit(ix);
}
#endif

void  RepoEditor::ContextMenu::browse()
{
   model->browse(ix, parent);
}
