#ifndef RepoEditorContextMenu_h
#define RepoEditorContextMenu_h

#include "RepoEditorModel.h"
#include <QtGui/QMenu>
#include <QtGui/QWidget>
#include <QtGui/QAction>

namespace RepoEditor {

   class ContextMenu : public QMenu {
      Q_OBJECT
   public:
      explicit ContextMenu(Model*    model,
                           QWidget*  parent);
   public:
      void  exec(QModelIndex    ix,
                 const QPoint&  pos);
   signals:
      void  edit(QModelIndex  ix);
   protected slots:
#ifndef REPO_EDITOR_ONE_DIALOG
      void  edit();
#endif
      void  browse();
   protected:
      Model*       model;
      QWidget*     parent;
      QModelIndex  ix;
   };

};

#endif
