#ifndef RepoEditorView_h
#define RepoEditorView_h

#include "RepoEditorModel.h"
#include "HTableView.h"
#include "RepoEditor.h"
#include "RepoEditorContextMenu.h"
#include <QtGui/QSortFilterProxyModel>

namespace RepoEditor {

   class View : public HTableView {
      Q_OBJECT
   public:
      explicit View(Model*    model,
                    QWidget*  parent = NULL);
   public:
      int              currentRow    ();
      void             setCurrentRow (int  row);
      QModelIndexList  selectedRows  ()         const;
   public:
      ContextMenu*  getContextMenu ();
   signals:
      void  currentChanged (int  currentRow,
                            int  previousRow);
      void  activated (const QModelIndex&  ix);
   protected slots:
      void  handleHorizontalHeaderClicked    (int                 column);
      void  handleClicked                    (const QModelIndex&  ix);
      void  handleCustomContextMenuRequested (const QPoint&       pos);
      void  currentChanged                   (const QModelIndex&  current,
                                              const QModelIndex&  previous);
      void  handleActivated                  (const QModelIndex&  ix);
   protected:
      Model*                  model;
      QSortFilterProxyModel*  sortedModel;
      ContextMenu*            contextMenu;
   };

};

#endif
