#include "ScrollableConfirmDialog.h"
#include <QtGui/QVBoxLayout>
#include <QtGui/QHBoxLayout>
#include <QtGui/QLabel>
#include <QtGui/QApplication>
#include <QtGui/QStyle>
#include "HScrollArea.h"
#include <QtGui/QPushButton>

ScrollableConfirmDialog::ScrollableConfirmDialog(QString   text,
                                                 QWidget*  parent)
   : QDialog(parent)
{
   setAttribute(Qt::WA_ShowModal, true);

   QVBoxLayout*  mainLayout = new QVBoxLayout;

   QHBoxLayout*  contentLayout = new QHBoxLayout;
   QLabel*       iconLabel     = new QLabel(this);
   iconLabel->setPixmap(QApplication::style()
                           ->standardPixmap(QStyle::SP_MessageBoxQuestion));
   contentLayout->addWidget(iconLabel);
   HScrollArea*  scrollArea    = new HScrollArea(this);
                 label         = new QLabel(text, scrollArea);
   scrollArea->setFrameStyle(QFrame::NoFrame | QFrame::Plain);
   scrollArea->setWidget(label);
   contentLayout->addWidget(scrollArea);
   mainLayout->addLayout(contentLayout);

   QHBoxLayout*  buttonsLayout = new QHBoxLayout;
   QPushButton*  okButton      = new QPushButton(tr("OK"),     this);
   QPushButton*  cancelButton  = new QPushButton(tr("Cancel"), this);
   buttonsLayout->addStretch(1);
   buttonsLayout->addWidget(okButton);
   buttonsLayout->addWidget(cancelButton);
   buttonsLayout->addStretch(1);
   connect(okButton,     SIGNAL(clicked()), this, SLOT(accept()));
   connect(cancelButton, SIGNAL(clicked()), this, SLOT(reject()));
   mainLayout->addLayout(buttonsLayout);

   setLayout(mainLayout);
}
