#include "ScrollableErrorDialog.h"
#include <QtGui/QVBoxLayout>
#include <QtGui/QHBoxLayout>
#include <QtGui/QLabel>
#include <QtGui/QApplication>
#include <QtGui/QStyle>
#include "HScrollArea.h"
#include <QtGui/QPushButton>

ScrollableErrorDialog::ScrollableErrorDialog(QString   text,
                                             QWidget*  parent)
   : QDialog(parent)
{
   setAttribute(Qt::WA_ShowModal, true);

   QVBoxLayout*  mainLayout = new QVBoxLayout;

   QHBoxLayout*  contentLayout = new QHBoxLayout;
   QLabel*       iconLabel     = new QLabel(this);
   iconLabel->setPixmap(QApplication::style()
                           ->standardPixmap(QStyle::SP_MessageBoxCritical));
   contentLayout->addWidget(iconLabel);
   HScrollArea*  scrollArea    = new HScrollArea(this);
                 label         = new QLabel(text, scrollArea);
   scrollArea->setFrameStyle(QFrame::NoFrame | QFrame::Plain);
   scrollArea->setWidget(label);
   contentLayout->addWidget(scrollArea);
   mainLayout->addLayout(contentLayout);

   QHBoxLayout*  buttonsLayout = new QHBoxLayout;
   QPushButton*  closeButton   = new QPushButton(tr("Close"), this);
   buttonsLayout->addStretch(1);
   buttonsLayout->addWidget(closeButton);
   buttonsLayout->addStretch(1);
   connect(closeButton, SIGNAL(clicked()), this, SLOT(accept()));
   mainLayout->addLayout(buttonsLayout);

   setLayout(mainLayout);
}
