#include "TextDialog.h"
#include <QtGui/QVBoxLayout>
#include <QtGui/QHBoxLayout>
#include <QtGui/QPushButton>

#define TEXT_DIMS  80, 24

TextDialog::TextDialog(QWidget*  parent)
   : QDialog(parent)
{
   setAttribute(Qt::WA_ShowModal, true);

   QVBoxLayout*  mainLayout = new QVBoxLayout;

   textEdit = new HTextEdit(TEXT_DIMS, this);
   textEdit->setReadOnly(true);
   textEdit->setLineWrapMode(QTextEdit::NoWrap);
   textEdit->setWordWrapMode(QTextOption::NoWrap);
   textEdit->setTabChangesFocus(true);
   mainLayout->addWidget(textEdit);

   QHBoxLayout*  buttonsLayout = new QHBoxLayout;
   QPushButton*  closeButton   = new QPushButton(tr("Close"), this);
   buttonsLayout->addStretch(1);
   buttonsLayout->addWidget(closeButton);
   connect(closeButton, SIGNAL(clicked()), this, SLOT(accept()));
   mainLayout->addLayout(buttonsLayout);

   setLayout(mainLayout);
}

void  TextDialog::setText(QString  text)
{
   textEdit->setPlainText(text);
}
