#include "YumIOC.h"

static bool    moduleInitialized = false;
static YumIO*  yumIO             = NULL;

#define DEFINE_INTERFACE(name)                              \
   static PyObject*  name(PyObject*  self, PyObject*  args) \
   {                                                        \
      return yumIO->name(self, args);                       \
   }

DEFINE_INTERFACE(stdoutWrite)
DEFINE_INTERFACE(stderrWrite)
DEFINE_INTERFACE(log)
DEFINE_INTERFACE(errorlog)
DEFINE_INTERFACE(collectProgress)
DEFINE_INTERFACE(grabMeterStart)
DEFINE_INTERFACE(grabMeterUpdate)
DEFINE_INTERFACE(grabMeterEnd)
DEFINE_INTERFACE(dsTsCheck)
DEFINE_INTERFACE(dsRestartLoop)
DEFINE_INTERFACE(userconfirm)
DEFINE_INTERFACE(reportDownloadSize)
DEFINE_INTERFACE(listTransaction)
DEFINE_INTERFACE(tsInitCallback)
DEFINE_INTERFACE(tsCallback)
DEFINE_INTERFACE(tsEvent)
DEFINE_INTERFACE(postTransactionOutput)

static PyMethodDef  methods[] = {
   { "stdoutWrite",           stdoutWrite,           METH_VARARGS },
   { "stderrWrite",           stderrWrite,           METH_VARARGS },
   { "log",                   log,                   METH_VARARGS },
   { "errorlog",              errorlog,              METH_VARARGS },
   { "collectProgress",       collectProgress,       METH_VARARGS },
   { "grabMeterStart",        grabMeterStart,        METH_VARARGS },
   { "grabMeterUpdate",       grabMeterUpdate,       METH_VARARGS },
   { "grabMeterEnd",          grabMeterEnd,          METH_VARARGS },
   { "dsTsCheck",             dsTsCheck,             METH_NOARGS  },
   { "dsRestartLoop",         dsRestartLoop,         METH_NOARGS  },
   { "userconfirm",           userconfirm,           METH_NOARGS  },
   { "reportDownloadSize",    reportDownloadSize,    METH_VARARGS },
   { "listTransaction",       listTransaction,       METH_VARARGS },
   { "tsInitCallback",        tsInitCallback,        METH_VARARGS },
   { "tsCallback",            tsCallback,            METH_VARARGS },
   { "tsEvent",               tsEvent,               METH_VARARGS },
   { "postTransactionOutput", postTransactionOutput, METH_VARARGS },
   { NULL,                    NULL                                },
};

extern void  YumIOC::initialize(YumIO*  yumIO_obj)
{
   yumIO = yumIO_obj;

   if (!moduleInitialized) {
      Py_InitModule("yumIOC", methods);
      moduleInitialized = true;
   }
}
