#ifndef YumIOCapturers_h
#define YumIOCapturers_h

#include <QtCore/QObject>
#include "YumIOCapturersMinion.h"

class YumIO;

class YumIOCapturers : public QObject {
   Q_OBJECT
public:
   explicit YumIOCapturers(YumIO*  yumIO);
   ~YumIOCapturers();
protected:
   YumIOCapturersMinion*  minion;
   YumIO*                 yumIO;
protected:
   int     originalStdoutFd;
   int     originalStderrFd;
   int     stdoutPipeFds[2];
   int     stderrPipeFds[2];
};

// This class is just a handy way to declare a single object that, when
// destroyed (e.g. on exit from a routine) will reset the YumIOCapturers.
class YumIOCapturersUser {
public:
   explicit YumIOCapturersUser(YumIOCapturers*&  yumIOCapturers,
                               YumIO*            yumIO)
      : yumIOCapturers(yumIOCapturers)
   {
      oldYumIOCapturers = yumIOCapturers;
      yumIOCapturers = new YumIOCapturers(yumIO);
   }
   ~YumIOCapturersUser() 
   { 
      delete yumIOCapturers;
      yumIOCapturers = oldYumIOCapturers;
   }
protected:
   YumIOCapturers*&  yumIOCapturers;
   YumIOCapturers*   oldYumIOCapturers;
};

#endif
