#include "YumIODialogsMinion.h"
#include <QtGui/QMessageBox>
#include "ScrollableConfirmDialog.h"
#include "ScrollableErrorDialog.h"

YumIODialogsMinion::YumIODialogsMinion(QWidget*  parent)
   : parent(parent)
{
}

void  YumIODialogsMinion::confirm (const QString&  caption,
                                   const QString&  text)
{
   ScrollableConfirmDialog  dialog(text, parent);
   dialog.setWindowTitle(caption);
   emit setResult(dialog.exec());
}

void  YumIODialogsMinion::warning (const QString&  caption,
                                   const QString&  text,
                                   const QString&  button0Text,
                                   const QString&  button1Text,
                                   const QString&  button2Text,
                                   int             defaultButtonNumber,
                                   int             escapeButtonNumber)
{
   int  result = QMessageBox::warning(parent, caption, text, 
                                      button0Text, button1Text, button2Text, 
                                      defaultButtonNumber, escapeButtonNumber);
   emit setResult(result);
}

void  YumIODialogsMinion::critical (const QString&  caption,
                                    const QString&  text,
                                    const QString&  button0Text,
                                    const QString&  button1Text,
                                    const QString&  button2Text,
                                    int             defaultButtonNumber,
                                    int             escapeButtonNumber)
{
   int  result = QMessageBox::critical(parent, caption, text, 
                                       button0Text, button1Text, button2Text, 
                                       defaultButtonNumber, escapeButtonNumber);
   emit setResult(result);
}

void  YumIODialogsMinion::scrollable (const QString&  caption,
                                      const QString&  text)
{
   ScrollableErrorDialog  dialog(text, parent);
   dialog.setWindowTitle(caption);
   dialog.exec();
   emit setResult(0);
}
