%define is_redhat %(if [ -e /etc/redhat-release ]; then echo 1; else echo 0; fi)
%define is_suse   %(if [ -e /etc/SuSE-release ];   then echo 1; else echo 0; fi)
%define pyver     %(if [ -d /usr/include/python2.5 ]; then echo 2.5; elif [ -d /usr/include/python2.4 ]; then echo 2.4; elif [ -d /usr/include/python2.3 ]; then echo 2.3; elif [ -d /usr/include/python2.2 ]; then echo 2.2; fi)
%define qt4_devel %(if [ "%{distro}" = "osu10.2" ]; then echo "libqt4-devel"; else echo "qt4-devel"; fi)

Summary: GUI RPM package manager
Name: nuu
Version: %{version}
Release: %{release}
License: GPL
Group: System Environment/Base
Source: nuu-%{version}.src.tar.gz
Packager: Concurrent Computer Corporation <nightstar@ccur.com>
URL: http://redhawk.ccur.com/nuu
Requires: python >= %{pyver} python <= %{pyver}.9
Requires: rpm-python >= 4.1.1 rpm-python < 4.5
Requires: yum >= 2.2.2 yum < 3.3
BuildRequires: python-devel >= %{pyver} python <= %{pyver}.9
BuildRequires: yum >= 2.2.2 yum < 3.3
BuildRequires: %{qt4_devel}
BuildRequires: inkscape
BuildRequires: rpm-devel
BuildRequires: libpng-devel
%if %{is_redhat}
Requires: usermode GConf2
BuildRequires: usermode
%endif
%if %{is_suse}
Requires: libgnomesu gconf2
BuildRequires: libgnomesu
%endif
%description

NUU, Network Update Utility, is a GUI RPM package manager that allows users
to download RPM packages from online yum repositories, and to install,
update, and remove those RPM packages.  It does dependency analysis
automatically.  NUU is based on Yum.

%prep
%setup

%build
%{__make}

%install
%if %{is_redhat}
%{__make} install BUILDROOT=${RPM_BUILD_ROOT} INSTALLSTRIP=
%else
%{__make} install BUILDROOT=${RPM_BUILD_ROOT}
%endif

%clean
%{__rm} -rf $RPM_BUILD_DIR/$RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION

%files
%defattr(-,root,root)
/usr/bin/nuu
%if %{is_redhat}
/etc/pam.d/nuu
/etc/security/console.apps/nuu
%endif
/usr/share/applications/nuu.desktop
/usr/share/man/man1/nuu.1.gz
/usr/share/nuu/nuu
/usr/share/nuu/webbrowser
/usr/share/nuu/mimeviewer
/usr/share/nuu/python/YumIO.py
/usr/share/nuu/python/YumIO.pyc
/usr/share/nuu/icons/check.png
/usr/share/nuu/icons/checkBox.png
/usr/share/nuu/icons/group.png
/usr/share/nuu/icons/install.png
/usr/share/nuu/icons/installBox.png
/usr/share/nuu/icons/noneBox.png
/usr/share/nuu/icons/out-of-date.png
/usr/share/nuu/icons/package.png
/usr/share/nuu/icons/remove.png
/usr/share/nuu/icons/removeBox.png
/usr/share/nuu/icons/suite.png
/usr/share/nuu/icons/up-to-date.png
/usr/share/nuu/icons/update.png
/usr/share/nuu/icons/updateBox.png
/usr/share/nuu/pixmaps/nuu.png
/usr/share/nuu/pixmaps/nuu.icon.png
%doc INSTALL DESKTOP LICENSE ChangeLog DESIGN TODO YUM doc/manual.pdf doc/html
